﻿Public Class Form1
    Dim buf() As String
    Dim buf_index As Integer

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        If My.Computer.Ports.SerialPortNames.Count = 0 Then
            MsgBox("Arduinoが見つからない" & vbCr & "Arduinoを接続し直してプログラムを再起動", vbExclamation, "ERROR")
            Exit Sub
        Else
            For Each sp_name As String In My.Computer.Ports.SerialPortNames
                ListBoxComport.Items.Add(sp_name)
            Next
            ListBoxComport.SetSelected(0, True)
        End If
    End Sub

    Delegate Sub ButtonEnableDelegate()
    Private Sub ButtonEnable()
        Button_run.Enabled = True
    End Sub

    Private Sub Button_run_Click(sender As System.Object, e As System.EventArgs) Handles Button_run.Click
        SerialPortArduino.PortName = ListBoxComport.SelectedItem
        SerialPortArduino.Open()
        Button_run.Enabled = False
        System.Threading.Thread.Sleep(1000) ' 直ぐに送信するとarduinoの準備が出来ていない
        buf = TextBox_cmd.Lines
        buf_index = 0
        SerialPortArduino.Write(buf(buf_index))
    End Sub

    Private Sub SerialPortArduino_DataReceived(sender As System.Object, e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPortArduino.DataReceived
        Dim rbytes As Integer
        Dim ButtonEnableMethod As New ButtonEnableDelegate(AddressOf ButtonEnable)

        rbytes = SerialPortArduino.BytesToRead  ' Ackコードの中身は見ない。１バイト送られてきたら何でもAckと見なす。
        buf_index = buf_index + 1
        If buf.Length = buf_index Then
            SerialPortArduino.Close()
            Button_run.Invoke(ButtonEnableMethod)
            Exit Sub
        Else
            If buf(buf_index).Length <> 0 Then
                SerialPortArduino.Write(buf(buf_index))
            Else
                SerialPortArduino.Write("#") ' 空白行は区切り文字だけを送る
            End If
        End If
    End Sub
End Class
